//
// set_tables.c (= set_tables.h)
//
// GKOS PC driver key scan codes, chordon shortcuts and other tables
//------------------------------------------------------------------
//		v.001 17.2.2006
//------------------------------------------------------------------
//
//       iChar[1]=0x41; iShifts[1]=0; gChar[1]="a";


#include <string>
#include <windows.h>


void gSendRest(); // Send single characters if no shortcut
static int  KeyCode = 1024;
static void gSK(int gKeyCode);
bool Monitor = FALSE;



//----params in tables
static int gCharRef[65];    	// ChordValue => GKOS Ref 
static char* gChar[257];   	// Character to show on GKOS Monitor Display - FIN
static char* gCharUS[257]; 	// Character to show on GKOS Monitor Display - US

static int  iChar[257];  	// 
static int  iCharUS[257];  	// 
static int  iShifts[257];   	// shift needed to get the symbol on PC key
static int  iShiftsUS[257]; 	// shift needed to get the symbol on PC key

static char AscToGKOS[256]; 	// for Chordon Shortcuts 
static char* SC[1024]; 		// for 780 Chordon Shortcuts
static int sc1;
static int sc2;

//----params in functions
static char A[2048];
static int ChordonByte[3]; // The 3 chordon shortcut data bytes !a [AKU]

static char* tx_char;
static char* tmp_char;

static int Nchar;



//--------------------------------

// RUN-TIME FUNCTIONS

//char*   BCX_TmpStr(size_t);
char*   chr(int,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0);


// is this really ASC ????
extern int asc (char *z,int index)
{
  return (unsigned char) z[index];
}

     
char *BCX_TmpStr (size_t Bites)
{
  static int   StrCnt;
  static char *StrFunc[2048];
  StrCnt=(StrCnt + 1) & 2047;
  if(StrFunc[StrCnt]) free (StrFunc[StrCnt]);
  return StrFunc[StrCnt]=(char*)calloc(Bites+128,1);
}

// tx_char$ = CHR$(35) <=> strcpy(tx_char,(char*)chr(35));
char *chr (int a,int b,int c,int d,int e,int f,int g,int h,int i,int j)
{
  register char *strtmp = BCX_TmpStr(11);
  strtmp[0]  = a;
  strtmp[1]  = b;
  strtmp[2]  = c;
  strtmp[3]  = d;
  strtmp[4]  = e;
  strtmp[5]  = f;
  strtmp[6]  = g;
  strtmp[7]  = h;
  strtmp[8]  = i;
  strtmp[9]  = j;
  strtmp[10] = 0;
  return strtmp;
}

// LEFT$() <=> left()
//    temp$ = LEFT$(tx_str$, 5)  <=>  strcpy(temp,(char*)left(tx_str,5));
char *left (char *S, int length)
{
  register int tmplen = strlen(S);
  char *strtmp = BCX_TmpStr(tmplen);
  strcpy (strtmp,S);
  if(length>tmplen)
    strtmp[tmplen] = 0;
  else
    strtmp[length] = 0;
  return strtmp;
}

// RIGHT$ <=> right()
//      tempA$ = RIGHT$(tx_str$, 4)  <=>  strcpy(tempA,(char*)right(tx_str,4));
char *right (char *S, int length)
{
  int tmplen = strlen(S);
  char *BCX_RetStr = BCX_TmpStr(tmplen);
  tmplen -= length;
  if (tmplen<0) tmplen = 0;
  return strcpy(BCX_RetStr, S + tmplen);
}


//MID$() <=> mid()
//  FOR n% = 1 to 5
//  tx_char$ = MID$(tx_str$, n%, 1)
//  NEXT n%
//          <=>
//  for(n=1; n<=5; n+=1)
//    {
//      strcpy(tx_char,(char*)mid(tx_str,n,1));
//    }
char *mid (char *S, int start, int length)
{
  register int tmplen = strlen(S);
  char *strtmp;
  if(start>tmplen||start<1) return BCX_TmpStr(1);
  if (length < 0) length = tmplen - start + 1;
  strtmp = BCX_TmpStr(length);
  strncpy(strtmp,&S[start-1],length);
  strtmp[length] = 0;
  return strtmp;
}


//---------------------------------

// -------------------


void gSendShortcut()
{
    // MessageBox(0, "Shortcut detected", "Test point...", MB_OK);          
                    gSK(74); // '#' TEST!!!!!  
                    gSK(ChordonByte[1]);
                    gSK(ChordonByte[2]);

}


void gSendRest() // Send single characters if no shortcut
                {
                    //gDisplay(ChordonByte[1]);
                    //gDisplay(ChordonByte[2]);
                    //gDisplay(ChordonByte[3]);
                    if (Monitor == FALSE)
                       {
   //   MessageBox(0, "gSendRest()", "Test...", MB_OK);          
                    gSK(75); // '' TEST!!!!!            
                    gSK(ChordonByte[1]);
                    gSK(ChordonByte[2]);
                    gSK(ChordonByte[3]);
                       }
                }
// --------------




//----------------------------------

// This is only for sending characters in GKOS shortcut strings.
// Single characters must be sent directly: gSK(74) = # etc.
void SENDCHAR (char *tx_char)
{
    KeyCode = AscToGKOS[(int) *tx_char];
    // Some special charcters coded as standard characters
               	  switch (KeyCode)
                  { 
                    case 127:// 'Delete Word Left'       
                       KeyCode = 188; gSK(188); // Shift
                       KeyCode = 62; gSK(62); // Ctrl
                       KeyCode = 47; gSK(47); // LeftArrow
                       KeyCode = 57; gSK(57); // Delete
                       return;
                    case 48:// 'Word Left'       
                       KeyCode = 62; gSK(62);
                       KeyCode = 47; gSK(47);
                       return;
                    case 52:// 'Word Right'       
                       KeyCode = 62; gSK(62);
                       KeyCode = 62; gSK(62);
                       return;
                    case 74:// 'Shift'   =  #  
                       KeyCode = 188; gSK(188);
                       return;
                    case 76:// 'Ctrl'    =  &
                       KeyCode = 62; gSK(62);
                       return;
                    case 88:// 'LeftArrow'= <      
                       KeyCode = 47; gSK(47);
                       return;
                    case 92:// 'RightArrow'= >     
                       KeyCode = 51; gSK(51);
                       return;
                    case 98:// 'BackSpace' = _    
                       KeyCode = 46; gSK(46);
                       return;
                    case 82:// 'Delete'    = *     
                       KeyCode = 57; gSK(57);
                       return;
                                          // Shift etc here...
                      
                  } // end of switch

   gSK(AscToGKOS[(int) *tx_char]);  
   // Test:
   //sprintf(EditStr,"%s%s",EditStr, tx_char);//ok
   //BCX_Set_Text(Edit1, (char*)EditStr);//ok
}

// For sending GKOS shortcut strings
void SENDSTR (char *tx_str)
{     
     for(Nchar=1; Nchar<=strlen(tx_str); Nchar+=1)
    {
      //strcpy(tx_char,(char*)mid(tx_str,Nchar,1)); // <-ERROR
      tx_char = (char*) mid(tx_str,Nchar,1); // <-OK
      SENDCHAR(tx_char);
//      A = (char*)mid(tx_str,Nchar,1); // ei
//      SENDCHAR(A);

    }
}







// =================FIRST CHARACTER is Special===============

void gSendSC_Period()
{    sc1 = 0;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// ------------------ 

void gSendSC_Comma()
{    sc1 = 41;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// -----------------

void gSendSC_Exclamation()
{    sc1 = 82;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}
// ------
 
void gSendSC_Question()
{    sc1 = 123;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// ------------

void gSendSC_Hyphen()
{    sc1 = 164;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}
// ------


void gSendSC_Apostrophe()
{
    sc1 = 205;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// ---------

void gSendSC_UpArrow()
{    sc1 = 246;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// ---------

void gSendSC_DownArrow()
{    sc1 = 287;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// ---------
void gSendSC_BackSpace()
{    sc1 = 328;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// ---------

void gSendSC_Space()
{    sc1 = 369;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// ---------

void gSendSC_Shift()
{    sc1 = 410;
	switch (ChordonByte[2])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    case 31:          sc2 = 31; break; // '.
    case 32:          sc2 = 32; break; // ',
    case 33:          sc2 = 33; break; // '!
    case 34:          sc2 = 34; break; // '?
    case 35:          sc2 = 35; break; // '-
    case 36:          sc2 = 36; break; // ''

    case 42:          sc2 = 37; break; // U (UpArrow)
    case 43:          sc2 = 38; break; // D (DnArrow)
    case 46:          sc2 = 39; break; // B (BackSpace)
    case 50:          sc2 = 40; break; // F (Space)
    case 59:          sc2 = 41; break; // S (Shift)           
    default:       gSendRest(); break;
    }
}

// ===================SECOND CHARCTER is special:=============================

// --------------

void gSendSC_Period2()
{    sc1 = 451;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}

// ------------------ 

void gSendSC_Comma2()
{    sc1 = 481;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}

// -----------------

void gSendSC_Exclamation2()
{    sc1 = 511;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}
// ------
 
void gSendSC_Question2()
{    sc1 = 541;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}

// ------------

void gSendSC_Hyphen2()
{    sc1 = 571;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}
// ------


void gSendSC_Apostrophe2()
{
    sc1 = 601;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}

// ---------

void gSendSC_UpArrow2()
{    sc1 = 631;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}

// ---------

void gSendSC_DownArrow2()
{    sc1 = 661;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}

// ---------
void gSendSC_BackSpace2()
{    sc1 = 691;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}

// ---------

void gSendSC_Space2()
{    sc1 = 721;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}

// ---------

void gSendSC_Shift2()
{    sc1 = 751;
	switch (ChordonByte[1])
    { 
    case 1:          sc2 = 1; break; // 'a
    case 2:          sc2 = 2; break; // 'b
    case 3:          sc2 = 3; break; // 'c
    case 4:          sc2 = 4; break; // 'd
    case 5:          sc2 = 5; break; // 'e
    case 6:          sc2 = 6; break; // 'f
    case 7:          sc2 = 7; break; // 'g
    case 8:          sc2 = 8; break; // 'h
    case 9:          sc2 = 9; break; // 'i
    case 10:          sc2 = 10; break; // j'
    case 11:          sc2 = 11; break; // 'k
    case 12:          sc2 = 12; break; // 'l
    case 13:          sc2 = 13; break; // 'm
    case 14:          sc2 = 14; break; // 'n
    case 15:          sc2 = 15; break; // 'o
    case 16:          sc2 = 16; break; // 'p
    case 17:          sc2 = 17; break; // 'q
    case 18:          sc2 = 18; break; // 'r
    case 19:          sc2 = 19; break; // 's
    case 20:          sc2 = 20; break; // 't
    case 21:          sc2 = 21; break; // 'u
    case 22:          sc2 = 22; break; // 'v
    case 23:          sc2 = 23; break; // 'w
    case 24:          sc2 = 24; break; // 'x
    case 25:          sc2 = 25; break; // 'y
    case 26:          sc2 = 26; break; // 'z
    case 27:          sc2 = 27; break; // 'u
    case 28:          sc2 = 28; break; // '
    case 29:          sc2 = 29; break; // '
    case 30:          sc2 = 30; break; // '
    default:       gSendRest(); break;
    }
}
// 781 chordon shortcuts total !!!


// After having found a sequence like [AKU] ! a [AKU]  this is entered:
void gSendShortcutX()
     {
     // TEST:
            /*        char *TempChar = gShortcut[286];
                    gPrint(TempChar); // includes Monitor == true
                    return;
                    */

	switch (ChordonByte[1]) 
            { 
                case 36: // '
                   // TempChar = "['] "; gPrint(TempChar);
                    gSendSC_Apostrophe();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);  
                    return; //break;  
                case 35: // -
                   // TempChar = "[-] "; gPrint(TempChar);
                    gSendSC_Hyphen();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break; 
                case 31: // .
                   // TempChar = "[.] "; gPrint(TempChar);
                    gSendSC_Period();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break; 
                case 32: // ,
                   // TempChar = "[,] "; gPrint(TempChar);
                    gSendSC_Comma();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break; 
                case 34: // ?
                   // TempChar = "[?] "; gPrint(TempChar);
                    gSendSC_Question();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break; 
                case 33: // !
                   // TempChar = "[!] "; gPrint(TempChar);
                    gSendSC_Exclamation();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break; 
                case 42: // UpArr
                   // TempChar = "[UpArrow] "; gPrint(TempChar);
                    gSendSC_UpArrow();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break; 
                case 43: // DnArr
                   // TempChar = "[DnArrow] "; gPrint(TempChar);
                    gSendSC_DownArrow();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break;
                case 46: // BackSpace
                   // TempChar = "[BackSpace] "; gPrint(TempChar);
                    gSendSC_BackSpace();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break; 
                case 50: // Space
                   // TempChar = "[Space] "; gPrint(TempChar);
                    gSendSC_Space();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break;
                case 188: // Shift
                   // TempChar = "[Shift] "; gPrint(TempChar);
                    gSendSC_Shift();   strcpy(A, (char*)SC[sc1 + sc2]);
                    SENDSTR(A); //gPrint(A);
                    return; //break; 
                default: ;
                }

            	switch (ChordonByte[2]) 
            	    { 
                            case 36: // '
                               // TempChar = "['] "; gPrint(TempChar);
                                gSendSC_Apostrophe2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);  
                                return; //break;  
                            case 35: // -
                               // TempChar = "[-] "; gPrint(TempChar);
                                gSendSC_Hyphen2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            case 31: // .
                               // TempChar = "[.] "; gPrint(TempChar);
                                gSendSC_Period2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            case 32: // ,
                               // TempChar = "[,] "; gPrint(TempChar);
                                gSendSC_Comma2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            case 34: // ?
                               // TempChar = "[?] "; gPrint(TempChar);
                                gSendSC_Question2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            case 33: // !
                               // TempChar = "[!] "; gPrint(TempChar);
                                gSendSC_Exclamation2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            case 42: // UpArr
                               // TempChar = "[UpArrow] "; gPrint(TempChar);
                                gSendSC_UpArrow2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            case 43: // DnArr
                               // TempChar = "[DnArrow] "; gPrint(TempChar);
                                gSendSC_DownArrow2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            case 46: // BackSpace
                               // TempChar = "[BackSpace] "; gPrint(TempChar);
                                gSendSC_BackSpace2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            case 50: // Space
                               // TempChar = "[Space] "; gPrint(TempChar);
                                gSendSC_Space2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break;
                            case 188: // Shift
                               // TempChar = "[Shift] "; gPrint(TempChar);
                                gSendSC_Shift2();   strcpy(A, (char*)SC[sc1 + sc2]);
                                SENDSTR(A); //gPrint(A);
                                return; //break; 
                            default: ;
                       }             
              gSendRest();
  
     } // end of function




//=====================================================================================


//--------------------------------

static void SetTables(void)
        {  
     // This table is needed for QWERTY input only

     // ChordValue  - GKOS Ref 

        gCharRef[1] = 1; 
        gCharRef[2] = 2; 
        gCharRef[4] = 3; 
        gCharRef[8] = 4; 
        gCharRef[16] = 5; 
        gCharRef[32] = 6; 
        gCharRef[24] = 7; 
        gCharRef[25] = 8; 
        gCharRef[26] = 9; 
        gCharRef[28] = 10; 
        gCharRef[48] = 11; 
        gCharRef[49] = 12; 
        gCharRef[50] = 13; 
        gCharRef[52] = 14; 
        gCharRef[3] = 15; 
        gCharRef[11] = 16; 
        gCharRef[19] = 17; 
        gCharRef[35] = 18; 
        gCharRef[6] = 19;
        gCharRef[14] = 20; 
        gCharRef[22] = 21; 
        gCharRef[38] = 22; 
        gCharRef[40] = 23; 
        gCharRef[41] = 24; 
        gCharRef[42] = 25; 
        gCharRef[44] = 26; 
        gCharRef[5] = 27; 
        gCharRef[13] = 28; 
        gCharRef[21] = 29; 
        gCharRef[37] = 30; 
        gCharRef[34] = 31; 
        gCharRef[20] = 32; 
        gCharRef[12] = 33; 
        gCharRef[33] = 34; 
        gCharRef[17] = 35; 
        gCharRef[10] = 36; 
        gCharRef[51] = 37; 
        gCharRef[30] = 38; 
        gCharRef[53] = 39; 
        gCharRef[46] = 40; 
        gCharRef[29] = 41; 
        gCharRef[9] = 42; 
        gCharRef[36] = 43; 
        gCharRef[27] = 44; 
        gCharRef[54] = 45; 
        gCharRef[7] = 46; 
        gCharRef[15] = 47; 
        gCharRef[23] = 48; 
        gCharRef[39] = 49; 
        gCharRef[56] = 50; 
        gCharRef[57] = 51;
        gCharRef[58] = 52; 
        gCharRef[60] = 53; 
        gCharRef[59] = 54; 
        gCharRef[61] = 55; 
        gCharRef[31] = 56; 
        gCharRef[62] = 57; 
        gCharRef[43] = 58; 
        gCharRef[18] = 59; 
        gCharRef[45] = 60; //126; // not 60 this time, <SYMB ON> 
        gCharRef[63] = 61; // 123-ABC 
        gCharRef[47] = 62; // Ctrl (must be 47 but was 46!!!)
        gCharRef[55] = 63; // Alt
       
        gCharRef[64] = 64; 
        gCharRef[65] = 65; 
         



// The GetOEMCP function retrieves the current original equipment
// manufacturer (OEM) code-page identifier for the system.
// UINT GetOEMCP(void);
// 1140 	IBM EBCDIC - U.S./Canada (037 + Euro symbol)
//  037 	IBM EBCDIC - U.S./Canada
// 1143 	IBM EBCDIC - Finland/Sweden (20278 + Euro symbol)
//20278 	IBM EBCDIC - Finland/Sweden


                
/*                             
                // intblah=ASC(v)
        char blah = 'v';
        int intblah = (int)blah;
        // cbluh=CHR$(13);
        int iEnter = 10; //13=CR, 10=LF
        char cEnter = (char)iEnter;

        int iSpace = 32;
        char cSpace = (char)iSpace;
        
        int iBackSpace = 8;
        char cBackSpace = (char)iBackSpace;

        int iTilde = 126;
        char cTilde = (char)iTilde;
 */
    
        // FIN/SWE table
        // PC scancode; 1=Shift, 2= AtGr; 3=Ctrl Monitor display; 9 = Shift KEY
        //                     
     // PC scancode ; Shifts needed  ; Monitor display

                       		    gChar[0]="[NULL]";
        iChar[1]=0x41; iShifts[1]=0; //gChar[1]="a";
        iChar[2]=0x42; iShifts[2]=0; //gChar[2]="b";
        iChar[3]=0x43; iShifts[3]=0; //gChar[3]="c";
        iChar[4]=0x44; iShifts[4]=0; //gChar[4]="d";
        iChar[5]=0x45; iShifts[5]=0; //gChar[5]="e";
        iChar[6]=0x46; iShifts[6]=0; //gChar[6]="f";
        iChar[7]=0x47; iShifts[7]=0; //gChar[7]="g";
        iChar[8]=0x48; iShifts[8]=0; //gChar[8]="h";
        iChar[9]=0x49; iShifts[9]=0; //gChar[9]="i";
        iChar[10]=0x4a; iShifts[10]=0; //gChar[10]="j";
        iChar[11]=0x4b; iShifts[11]=0; //gChar[11]="k";
        iChar[12]=0x4c; iShifts[12]=0; //gChar[12]="l";
        iChar[13]=0x4d; iShifts[13]=0; //gChar[13]="m";
        iChar[14]=0x4e; iShifts[14]=0; //Char[14]="n";
        iChar[15]=0x4f; iShifts[15]=0; //gChar[15]="o";
        iChar[16]=0x50; iShifts[16]=0; //gChar[16]="p";
        iChar[17]=0x51; iShifts[17]=0; //gChar[17]="q";
        iChar[18]=0x52; iShifts[18]=0; //gChar[18]="r";
        iChar[19]=0x53; iShifts[19]=0; //gChar[19]="s";
        iChar[20]=0x54; iShifts[20]=0; //gChar[20]="t";
        iChar[21]=0x55; iShifts[21]=0; //gChar[21]="u";
        iChar[22]=0x56; iShifts[22]=0; //gChar[22]="v";
        iChar[23]=0x57; iShifts[23]=0; //gChar[23]="w";
        iChar[24]=0x58; iShifts[24]=0; //gChar[24]="x";
        iChar[25]=0x59; iShifts[25]=0; //gChar[25]="y";
        iChar[26]=0x5a; iShifts[26]=0; //gChar[26]="z";
        iChar[27]=0x55; iShifts[27]=0; //gChar[27]="";   //  / th
        iChar[28]=0xdd; iShifts[28]=0; //gChar[28]="";   //  / and
        iChar[29]=0xde; iShifts[29]=0; //gChar[29]="";   //  / the
        iChar[30]=0xc0; iShifts[30]=0; //gChar[30]="";   //  / of
        iChar[31]=0xbe; iShifts[31]=0; //gChar[31]=".";
        iChar[32]=0xbc; iShifts[32]=0; //gChar[32]=",";
        iChar[33]=0x31; iShifts[33]=1; //gChar[33]="!"; // shift 1
        iChar[34]=0xbb; iShifts[34]=1; //gChar[34]="?"; // 
        iChar[35]=0xbd; iShifts[35]=0; //gChar[35]="-"; // 
        iChar[36]=0xbf; iShifts[36]=0; //gChar[36]="'"; // ????
        iChar[37]=0xbb; iShifts[37]=2; //gChar[37]="<backslash>";  //
        iChar[38]=0x37; iShifts[38]=1; //gChar[38]="/"; // 
        iChar[39]=0xba; iShifts[39]=0; //gChar[39]=""; // ()
        iChar[40]=0xba; iShifts[40]=2; //gChar[40]="~"; // tilde, 'worm'
        iChar[41]=0xba; iShifts[41]=1; //gChar[41]="^";  //  ^
        iChar[42]=0x26; iShifts[42]=0; //gChar[42]="<UpArrow>"; // arrow up
        iChar[43]=0x28; iShifts[43]=0; //gChar[43]="<DownArrow>"; // arrow down
        iChar[44]=0x21; iShifts[44]=0; //gChar[44]="<PageUp>"; // page up
        iChar[45]=0x22; iShifts[45]=0; //gChar[45]="<PageDown>"; // page down
        iChar[46]=0x08; iShifts[46]=0; //gChar[46]="<BkSp>"; //&cBackSpace; //<Backspace>; // backspace 8
        iChar[47]=0x25; iShifts[47]=0; //gChar[47]="<LeftArrow>"; // arrow left
        iChar[48]=0x25; iShifts[48]=3; //gChar[48]="<Word Left>"; // word left
        iChar[49]=0x24; iShifts[49]=0; //gChar[49]="<Home>"; // home
        iChar[50]=0x20; iShifts[50]=0; //gChar[50]=" "; // &cSpace; // space
        iChar[51]=0x27; iShifts[51]=0; //gChar[51]="<RightArrow>"; // arrow right
        iChar[52]=0x27; iShifts[52]=3; //gChar[52]="<Word Right>"; // word right
        iChar[53]=0x23; iShifts[53]=0; //gChar[53]="<End>"; // end
        iChar[54]=0x0d; iShifts[54]=0; //gChar[54]="<ENTER>"; // &cEnter ; // ENTER d'13'
        iChar[55]=0x09; iShifts[55]=0; //gChar[55]="<Tab>"; // tab
        iChar[56]=0x1b; iShifts[56]=0; //gChar[56]="<Esc>"; // esc
        iChar[57]=0x2e; iShifts[57]=0; //gChar[57]="<Del>"; // delete
        iChar[58]=0x2d; iShifts[58]=0; //gChar[58]="<Ins>"; // indsert
        iChar[59]=0x10; iShifts[59]=0; //gChar[59]="<SHIFT ON>"; // Shift ON (0x10, 0xa0, 0xa1)
        iChar[60]=0x99; iShifts[60]=0; //gChar[60]="<SYMB>"; //<IR Header>"; // IR link header
        iChar[61]=0x99; iShifts[61]=0; //gChar[61]="<123-ABC>"; // 123-ABC
        iChar[62]=0xa2; iShifts[62]=0; //gChar[62]="<Ctrl ON>"; // Ctrl ON
        iChar[63]=0x12; iShifts[63]=0; //gChar[63]="<Alt ON>"; // Alt ON
        iChar[64]=0x31; iShifts[64]=0; //gChar[64]="1";        
        iChar[65]=0x32; iShifts[65]=0; //gChar[65]="2";        
        iChar[66]=0x33; iShifts[66]=0; //gChar[66]="3";
        iChar[67]=0x34; iShifts[67]=0; //gChar[67]="4";
        iChar[68]=0x35; iShifts[68]=0; //gChar[68]="5";
        iChar[69]=0x36; iShifts[69]=0; //gChar[69]="6";
        iChar[70]=0x30; iShifts[70]=0; //gChar[70]="0";
        iChar[71]=0x37; iShifts[71]=0; //gChar[71]="7";
        iChar[72]=0x38; iShifts[72]=0; //gChar[72]="8";
        iChar[73]=0x39; iShifts[73]=0; //gChar[73]="9";
        iChar[74]=0x33; iShifts[74]=1; //gChar[74]="#";        
        iChar[75]=0xdc; iShifts[75]=1; //gChar[75]="";        
        iChar[76]=0x36; iShifts[76]=1; //gChar[76]="&";
        iChar[77]=0x32; iShifts[77]=2; //gChar[77]="@";
        iChar[78]=0xbb; iShifts[78]=0; //gChar[78]="+";
        iChar[79]=0x35; iShifts[79]=1; //gChar[79]="%";
        iChar[80]=0x30; iShifts[80]=1; //gChar[80]="=";  //
        iChar[81]=0x59; iShifts[81]=0; //gChar[81]="<yen>";
        iChar[82]=0xbf; iShifts[82]=1; //gChar[82]="*";  //
        iChar[83]=0x35; iShifts[83]=2; //gChar[83]="";
        iChar[84]=0x34; iShifts[84]=2; //gChar[84]="$";        
        iChar[85]=0x33; iShifts[85]=2; //gChar[85]="";        
        iChar[86]=0x38; iShifts[86]=1; //gChar[86]="(";
        iChar[87]=0x38; iShifts[87]=2; //gChar[87]="[";        // US: [ FIN: 
        iChar[88]=0xe2; iShifts[88]=0; //gChar[88]="<"; 
        iChar[89]=0x37; iShifts[89]=2; //gChar[89]="{";
        iChar[90]=0x39; iShifts[90]=1; //gChar[90]=")";
        iChar[91]=0x39; iShifts[91]=2; //gChar[91]="]";        // US: ] FIN: 
        iChar[92]=0xe2; iShifts[92]=1; //gChar[92]=">";
        iChar[93]=0x30; iShifts[93]=2; //gChar[93]="}";
        iChar[94]=0xbe; iShifts[94]=1; //gChar[94]=":";        
        iChar[95]=0xbc; iShifts[95]=1; //gChar[95]=";";  //US: ;: FIN: 
        iChar[96]=0x31; iShifts[96]=1; //gChar[96]="<inv.!>";
        iChar[97]=0xbb; iShifts[97]=1; //gChar[97]="<inv.?>";
        iChar[98]=0xbd; iShifts[98]=1; //gChar[98]="_";
        iChar[99]=0x32; iShifts[99]=1; //gChar[99]="<quote>"; // " (quote)
        iChar[100]=0xdb; iShifts[100]=0; //gChar[100]="";
        iChar[101]=0xdb; iShifts[101]=1; //gChar[101]="`";
        iChar[102]=0xe2; iShifts[102]=2; //gChar[102]="|";
        iChar[103]=0xdc; iShifts[103]=0; //gChar[103]="";
        iChar[104]=0x34; iShifts[104]=1; //gChar[104]="";        
        iChar[105]=0xdd; iShifts[105]=1; //gChar[105]="<inv.^>";        
        iChar[106]=0x70; iShifts[106]=0; //gChar[106]="<F1>";
        iChar[107]=0x71; iShifts[107]=0; //gChar[107]="<F2>";
        iChar[108]=0x72; iShifts[108]=0; //gChar[108]="<F3>";
        iChar[109]=0x73; iShifts[109]=0; //gChar[109]="<F4>";
        iChar[110]=0x74; iShifts[110]=0; //gChar[110]="<F5>";
        iChar[111]=0x75; iShifts[111]=0; //gChar[111]="<F6>";
        iChar[112]=0x76; iShifts[112]=0; //gChar[112]="<F7>";
        iChar[113]=0x77; iShifts[113]=0; //gChar[113]="<F8>";
        iChar[114]=0x78; iShifts[114]=0; //gChar[114]="<F9>";        
        iChar[115]=0x79; iShifts[115]=0; //gChar[115]="<F10>";        
        iChar[116]=0x7a; iShifts[116]=0; //gChar[116]="<F11>";
        iChar[117]=0x7b; iShifts[117]=0; //gChar[117]="<F12>";
        iChar[118]=0x41; iShifts[118]=0; //gChar[118]="<AltGr ON>"; // !!!
        iChar[119]=0x14; iShifts[119]=0; //gChar[119]="<CAPS ON>";  // !!!
        iChar[120]=0x90; iShifts[120]=0; //gChar[120]="<Num Lock ON>"; // !!!
        iChar[121]=0x5d; iShifts[121]=0; //gChar[121]="<Windows menu>";
        iChar[122]=0x5b; iShifts[122]=0; //gChar[122]="<Windows start>";
        iChar[123]=0x2c; iShifts[123]=0; //gChar[123]="<Print Screen>";
        iChar[124]=0x91; iShifts[124]=0; //gChar[124]="<Scroll Lock ON>";        
        iChar[125]=0x13; iShifts[125]=0; //gChar[125]="<Pause/Break>";        
        iChar[126]=0x00; iShifts[126]=0; //gChar[126]="<SYMB>"; // !!!
        iChar[127]=0x00; iShifts[127]=0; //gChar[127]="<reserved>"; // !!!
        
        iChar[128]=0x00; iShifts[128]=0; //gChar[128]=" <Mouse data Start> ";
        iChar[129]=0xaf; iShifts[129]=0; //gChar[129]="Volume +";
        iChar[130]=0xb1; iShifts[130]=0; //gChar[130]="Navi Left / Skip-";
        iChar[131]=0xae; iShifts[131]=0; //gChar[131]="Volume -";
        iChar[132]=0x00; iShifts[132]=0; //gChar[132]="Channel +";
        iChar[133]=0xb0; iShifts[133]=0; //gChar[133]="Navi Right / Skip+";
        iChar[134]=0x00; iShifts[134]=0; //gChar[134]="Channel -";
        
        iChar[141]=0xad; iShifts[141]=0; //gChar[141]="Mute/(Menu)"; // M


        iChar[143]=0xb3; iShifts[143]=0; //gChar[143]="Play/Pause"; // O
        
        iChar[174]=0xb2; iShifts[174]=0; //gChar[174]="Stop"; //BackSpace

        iChar[178]=0xb3; iShifts[178]=0; //gChar[178]="Play/Pause"; // Space
                        
        iChar[187]=0x10; iShifts[187]=0; //gChar[187]="<Shift OFF>";
        iChar[188]=0x99; iShifts[188]=9; //gChar[188]="<Shift KEY>";

        iChar[189]=0; iShifts[189]=0; //gChar[189]="<123-ABC OFF>";

        iChar[190]=0xa2; iShifts[190]=0; //gChar[190]="<Ctrl OFF>"; // Key up
        iChar[191]=0x12; iShifts[191]=0; //gChar[191]="<Alt OFF>";  // Key up


                        gChar[238]="<IR Addr6>";
                        gChar[239]="<IR Addr7>";
                        gChar[240]="<IR Addr0>";
                        gChar[241]="<IR Addr1>";
                        gChar[242]="<IR Addr2>";
                        gChar[243]="<IR Addr3>";
                        gChar[244]="<IR Addr4>";
                        gChar[245]="<IR Addr5>";

        iChar[246]=0x41; iShifts[246]=0; //gChar[246]="<AltGr OFF>"; // Key up
        iChar[247]=0x14; iShifts[247]=0; //gChar[247]="<CAPS OFF>";  // Key down & up
        iChar[248]=0x90; iShifts[248]=0; //gChar[248]="<Num Lock OFF>"; // Key down&up
        iChar[252]=0x91; iShifts[252]=0; //gChar[252]="<Scroll Lock OFF>"; // Key down&up       
        iChar[253]=0; iShifts[253]=0; //gChar[253]="<AKU>"; // All keys up????       


                        gChar[254]="<SYMB OFF>"; // (SYMB OFF not used)
        iChar[254]=0x00; iShifts[254]=0; //gChar[254]="<SYMB OFF>"; // virtual
        iChar[255]=0x00; iShifts[255]=0; //gChar[255]=" <Mouse data End> ";



        // create US version of the table
        // ==============================
        
        // fist make a copy
        int i; i = 1;
        while (i < 256)
        {
        iShiftsUS[i]=0;		// clear all shifts first (1=SHIFT, 2=AltGr)
	iCharUS[i] = iChar[i];  // copy character codes from FIN/SWE kbd first
    gCharUS[i] = gChar[i];
        ++i;
        }
        
        // then define differencies:

        //              ;1=Shift, 2=AtGr(=Ctrl+Alt), 9=National Shortcut
        // PC code      ; Shifts needed  ; Monitor display
        iCharUS[27]=0x00; iShiftsUS[27]=9; //gCharUS[27]="th";     //  / th
        iCharUS[28]=0x00; iShiftsUS[28]=9; //gCharUS[28]="a ";   //  / and_ > a_
        iCharUS[29]=0x00; iShiftsUS[29]=9; //gCharUS[29]="the ";   //  / the
        iCharUS[30]=0x00; iShiftsUS[30]=9; //gCharUS[30]="of ";    //  / of
        // Each character sequence above is always sent as series of letters a-z
        
        iCharUS[31]=0xbe; iShiftsUS[31]=0; //gCharUS[31]=".";
        iCharUS[32]=0xbc; iShiftsUS[32]=0; //gCharUS[32]=",";
        iCharUS[33]=0x31; iShiftsUS[33]=1; //gCharUS[33]="!"; // shift 1
        iCharUS[34]=0xbb; iShiftsUS[34]=1; //gCharUS[34]="?"; // 
        iCharUS[35]=0xbd; iShiftsUS[35]=0; //gCharUS[35]="-"; // 
        iCharUS[36]=0xbf; iShiftsUS[36]=0; //gCharUS[36]="'"; // ????
        iCharUS[37]=0xbf; iShiftsUS[37]=0; //gCharUS[37]="<backslash>";  //
        iCharUS[38]=0xbd; iShiftsUS[38]=0; //gCharUS[38]="/"; // 
        iCharUS[39]=0x00; iShiftsUS[39]=9; //gCharUS[39]="and "; // ()
        iCharUS[40]=0xdc; iShiftsUS[40]=1; //gCharUS[40]="~"; // tilde, 'worm'
        iCharUS[41]=0x00; iShiftsUS[41]=9; //gCharUS[41]="to ";  //  ^
        
        iCharUS[74]=0x33; iShiftsUS[74]=1; //gCharUS[74]="#";        
        iCharUS[75]=0x00; iShiftsUS[75]=0; //gCharUS[75]="";        
        iCharUS[76]=0x00; iShiftsUS[76]=0; //gCharUS[76]="&";
        iCharUS[77]=0x32; iShiftsUS[77]=1; //gCharUS[77]="@";
        iCharUS[78]=0xdb; iShiftsUS[78]=1; //gCharUS[78]="+";
        iCharUS[79]=0x35; iShiftsUS[79]=1; //gCharUS[79]="%";
        iCharUS[80]=0xdb; iShiftsUS[80]=0; //gCharUS[80]="=";  //
        iCharUS[81]=0x59; iShiftsUS[81]=0; //gCharUS[81]="<yen>";
        iCharUS[82]=0x38; iShiftsUS[82]=1; //gCharUS[82]="*";  //
        iCharUS[83]=0x45; iShiftsUS[83]=0; //gCharUS[83]="";
        iCharUS[84]=0x34; iShiftsUS[84]=1; //gCharUS[84]="$";        
        iCharUS[85]=0x00; iShiftsUS[85]=0; //gCharUS[85]="";        
        iCharUS[86]=0x39; iShiftsUS[86]=1; //gCharUS[86]="(";
        iCharUS[87]=0xdd; iShiftsUS[87]=0; //gCharUS[87]="[";        // US: [ FIN: 
        iCharUS[88]=0xbc; iShiftsUS[88]=1; //gCharUS[88]="<"; 
        iCharUS[89]=0xdd; iShiftsUS[89]=1; //gCharUS[89]="{";
        iCharUS[90]=0x30; iShiftsUS[90]=1; //gCharUS[90]=")";
        iCharUS[91]=0xba; iShiftsUS[91]=0; //gCharUS[91]="]";        // US: ] FIN: 
        iCharUS[92]=0xbe; iShiftsUS[92]=1; //gCharUS[92]=">";
        iCharUS[93]=0xba; iShiftsUS[93]=1; //gCharUS[93]="}";
        iCharUS[94]=0xc0; iShiftsUS[94]=1; //gCharUS[94]=":";        
        iCharUS[95]=0xc0; iShiftsUS[95]=0; //gCharUS[95]=";";  //US: ;: FIN: 
        iCharUS[96]=0x31; iShiftsUS[96]=1; //gCharUS[96]="<inv.!>";
        iCharUS[97]=0xbd; iShiftsUS[97]=1; //gCharUS[97]="<inv.?>";
        iCharUS[98]=0xbb; iShiftsUS[98]=1; //gCharUS[98]="_";
        iCharUS[99]=0xde; iShiftsUS[99]=1; //gCharUS[99]="<quote>"; // " (quote)
        iCharUS[100]=0x00; iShiftsUS[100]=0; //gCharUS[100]="";
        iCharUS[101]=0xdc; iShiftsUS[101]=1; //gCharUS[101]="`";
        iCharUS[102]=0xbf; iShiftsUS[102]=1; //gCharUS[102]="|";
        iCharUS[103]=0x00; iShiftsUS[103]=0; //gCharUS[103]="";
        iCharUS[104]=0x36; iShiftsUS[104]=1; //gCharUS[104]="";  // US ^ (difference)      
        iCharUS[105]=0x00; iShiftsUS[105]=0; //gCharUS[105]="<inv.^>";        

        // Create Shortcut table (See GKOS Shortcuts defined at http://gkos.net)
        // <AKU> xx <AKU>, where xx = !j  for example, and <AKU> = All Keys Up condition

//---------------------------------------------------------
        
        // This table is used in chordon shortcuts:
        
        AscToGKOS[8] = 46;// backspace        
        AscToGKOS[32] = 50;// space        

        AscToGKOS[35] = 74;// # used as a Shift in shortcuts         
        AscToGKOS[38] = 76;// & used as a Ctrl in shortcuts (Word Right/Left)         
        AscToGKOS[60] = 88;// < used as a LeftArrow in shortcuts         
        AscToGKOS[62] = 92;// > used as a RghtArrow in shortcuts         
        AscToGKOS[95] = 98;// _ used as a backspace in shortcuts         
        AscToGKOS[42] = 82;// * used as a Del in shortcuts         
        AscToGKOS[37] = 127;// % used as a Del Word in shortcuts         

        AscToGKOS[39] = 36;//'         
        AscToGKOS[45] = 35;//-         

        AscToGKOS[48] = 70;// 0         
        AscToGKOS[49] = 64;// 1       
        AscToGKOS[50] = 65;// 2        
        AscToGKOS[51] = 66;// 3        
        AscToGKOS[52] = 67;// 4        
        AscToGKOS[53] = 68;// 5        
        AscToGKOS[54] = 69;// 6        
        AscToGKOS[55] = 71;// 7        
        AscToGKOS[56] = 72;// 8        
        AscToGKOS[57] = 73;// 9        

        AscToGKOS[97] = 1;//a         
        AscToGKOS[98] = 2;//         
        AscToGKOS[99] = 3;//         
        AscToGKOS[100] = 4;//         
        AscToGKOS[101] = 5;//         
        AscToGKOS[102] = 6;//         
        AscToGKOS[103] = 7;//         
        AscToGKOS[104] = 8;//         
        AscToGKOS[105] = 9;//         
        AscToGKOS[106] = 10;//         
        AscToGKOS[107] = 11;//         
        AscToGKOS[108] = 12;//         
        AscToGKOS[109] = 13;//         
        AscToGKOS[110] = 14;//         
        AscToGKOS[111] = 15;//         
        AscToGKOS[112] = 16;//         
        AscToGKOS[113] = 17;//         
        AscToGKOS[114] = 18;//         
        AscToGKOS[115] = 19;//         
        AscToGKOS[116] = 20;//         
        AscToGKOS[117] = 21;//         
        AscToGKOS[118] = 22;//         
        AscToGKOS[119] = 23;//         
        AscToGKOS[120] = 24;//         
        AscToGKOS[121] = 25;//         
        AscToGKOS[122] = 26;//         
        AscToGKOS[123] = 27;//         
        AscToGKOS[124] = 28;//         
        AscToGKOS[125] = 29;//         
        AscToGKOS[126] = 30;//         
        AscToGKOS[127] = 57;//         
        //AscToGKOS[] = ;//         
        
        
//; ASCII CODES:
//;000  (nul)  016  (dle)  032 sp  048 0  064 @  080 P  096 `  112 p
//;001  (soh)  017  (dc1)  033 !   049 1  065 A  081 Q  097 a  113 q
//;002  (stx)  018  (dc2)  034 "   050 2  066 B  082 R  098 b  114 r
//;003  (etx)  019  (dc3)  035 #   051 3  067 C  083 S  099 c  115 s
//;004  (eot)  020  (dc4)  036 $   052 4  068 D  084 T  100 d  116 t
//;005  (enq)  021  (nak)  037 %   053 5  069 E  085 U  101 e  117 u
//;006  (ack)  022  (syn)  038 &   054 6  070 F  086 V  102 f  118 v
//;007  (bel)  023  (etb)  039 '   055 7  071 G  087 W  103 g  119 w
//;008  (bs)   024  (can)  040 (   056 8  072 H  088 X  104 h  120 x
//;009  (tab)  025  (em)   041 )   057 9  073 I  089 Y  105 i  121 y
//;010  (lf)   026  (eof)  042 *   058 :  074 J  090 Z  106 j  122 z
//;011  (vt)   027  (esc)  043 +   059 ;  075 K  091 [  107 k  123 {
//;012  (np)   028  (fs)   044 ,   060 <  076 L  092    108 l  124 |
//;013  (cr)   029  (gs)   045 -   061 =  077 M  093 ]  109 m  125 }
//;014  (so)   030  (rs)   046 .   062 >  078 N  094 ^  110 n  126 ~
//;015  (si)   031  (us)   047 /   063 ?  079 O  095 _  111 o  127 (del)


// ================CHORDON SHORTCUTS:===========================

//        AscToGKOS[35] = 74;// # used as a Shift in shortcuts         
//        AscToGKOS[38] = 76;// & used as a Ctrl in shortcuts (Word Right/Left)         
//        AscToGKOS[60] = 88;// < used as a LeftArrow in shortcuts         
//        AscToGKOS[62] = 92;// > used as a RghtArrow in shortcuts         
//        AscToGKOS[95] = 98;// _ used as a backspace in shortcuts         
//        AscToGKOS[42] = 82;// * used as a Del in shortcuts         
//        AscToGKOS[37] = 127;// % used as a Del Word in shortcuts         


        sc1 = 0; // Period         .a
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "on "; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "are "; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "for "; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S

        sc1 = 41; // Comma         ,a
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S

        sc1 = 82; // Exclamation   !a
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S
    

        sc1 = 123; // Question     ?a
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S
      

        sc1 = 164; // Hyphen       -a
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "has "; // 'h
        SC[9+sc1] = "in "; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "they "; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "their "; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "have "; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S
        

        sc1 = 205; // Apostrophe   'a
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "is "; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "'s "; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "you "; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "your "; // '.
        SC[32+sc1] = "----1"; // ',
        SC[33+sc1] = "it "; // '!
        SC[34+sc1] = "----3"; // '?
        SC[35+sc1] = "----4"; // '-
        SC[36+sc1] = "----5"; // ''
        SC[37+sc1] = "----6"; // 'U
        SC[38+sc1] = "----7"; // 'D
        SC[38+sc1] = "----8"; // 'B
        SC[40+sc1] = "----9"; // 'F
        SC[41+sc1] = "it's "; // 'S
        

        sc1 = 246; // UpArrow = U    Ua
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "he "; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "his "; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S
        

        sc1 = 287; // DownArrow = D    Da
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S
        

        sc1 = 328; // BackSpace = B      Ba
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S
        

        sc1 = 369; // Space = F (Forward)     Fa
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "-----"; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "-----"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "-----"; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "-----"; // 'B
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S
        

        sc1 = 410; // Shift = S              Sa
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "#i "; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "me "; // 'm
        SC[14+sc1] = "in "; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "us "; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '
        SC[31+sc1] = "my "; // '.
        SC[32+sc1] = "-----"; // ',
        SC[33+sc1] = "it"; // '!
        SC[34+sc1] = "-----"; // '?
        SC[35+sc1] = "-----"; // '-
        SC[36+sc1] = "#i'm "; // ''
        SC[37+sc1] = "-----"; // 'U
        SC[38+sc1] = "-----"; // 'D
        SC[38+sc1] = "*"; // 'B  Ctrl LeftArrow Delete
        SC[40+sc1] = "-----"; // 'F
        SC[41+sc1] = "-----"; // 'S
        
        // ========just the SECOND CHAR is special===========
        
        sc1 = 451; // Period             a.
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '

        sc1 = 481; // Comma              a,
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "this "; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '

        sc1 = 511; // Exclamation        a!
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "could "; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "would "; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "should "; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '


        sc1 = 541; // Question      a?
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "will "; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "shall "; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '


        sc1 = 571; // Hyphen          a-
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "hasn't "; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "them "; // '
        SC[30+sc1] = "-----"; // '


        sc1 = 601; // Apostrophe      a'
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "isn't "; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "yours "; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '


        sc1 = 631; // UpArrow       aU
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "haven't "; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '


        sc1 = 661; // DownArrow       aD
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "can "; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '


        sc1 = 691; // BackSpace       aB
        SC[1+sc1] = "_"; // 'a
        SC[2+sc1] = "_"; // 'b
        SC[3+sc1] = "_"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "_"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "_"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "-----"; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "they "; // 'u  RISKY !!!!
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '


        sc1 = 721; // Space = F (Forward)   aF
        SC[1+sc1] = "-----"; // 'a
        SC[2+sc1] = "-----"; // 'b
        SC[3+sc1] = "-----"; // 'c
        SC[4+sc1] = "-----"; // 'd
        SC[5+sc1] = "-----"; // 'e
        SC[6+sc1] = "-----"; // 'f
        SC[7+sc1] = "-----"; // 'g
        SC[8+sc1] = "-----"; // 'h
        SC[9+sc1] = "-----"; // 'i
        SC[10+sc1] = "-----"; // 'j
        SC[11+sc1] = "-----"; // 'k
        SC[12+sc1] = "-----"; // 'l
        SC[13+sc1] = "-----"; // 'm
        SC[14+sc1] = "-----"; // 'n
        SC[15+sc1] = "-----"; // 'o
        SC[16+sc1] = "-----"; // 'p
        SC[17+sc1] = "-----"; // 'q
        SC[18+sc1] = "-----"; // 'r
        SC[19+sc1] = "-----"; // 's
        SC[20+sc1] = "-----"; // 't
        SC[21+sc1] = "-----"; // 'u
        SC[22+sc1] = "-----"; // 'v
        SC[23+sc1] = "we "; // 'w
        SC[24+sc1] = "-----"; // 'x
        SC[25+sc1] = "-----"; // 'y
        SC[26+sc1] = "-----"; // 'z
        SC[27+sc1] = "-----"; // 'u
        SC[28+sc1] = "-----"; // '
        SC[29+sc1] = "-----"; // '
        SC[30+sc1] = "-----"; // '


        sc1 = 751; // Shift                 aS
        SC[1+sc1] = "-1--- "; // 'a
        SC[2+sc1] = "-2--- "; // 'b
        SC[3+sc1] = "-3--- "; // 'c
        SC[4+sc1] = "-4--- "; // 'd
        SC[5+sc1] = "-5--- "; // 'e
        SC[6+sc1] = "-6--- "; // 'f
        SC[7+sc1] = "-7--- "; // 'g
        SC[8+sc1] = "him "; // 'h
        SC[9+sc1] = "#i'm "; // 'i
        SC[10+sc1] = "--10-- "; // 'j
        SC[11+sc1] = "--11-- "; // 'k
        SC[12+sc1] = "--12-- "; // 'l
        SC[13+sc1] = "mine "; // 'm
        SC[14+sc1] = "--14--- "; // 'n
        SC[15+sc1] = "--15--- "; // 'o
        SC[16+sc1] = "--16--- "; // 'p
        SC[17+sc1] = "--17--- "; // 'q
        SC[18+sc1] = "--18--- "; // 'r
        SC[19+sc1] = "she "; // 's
        SC[20+sc1] = "--19-- "; // 't
        SC[21+sc1] = "--20--- "; // 'u
        SC[22+sc1] = "--21--- "; // 'v
        SC[23+sc1] = "--22--- "; // 'w
        SC[24+sc1] = "--23--- "; // 'x
        SC[25+sc1] = "--24--- "; // 'y
        SC[26+sc1] = "--25--- "; // 'z
        SC[27+sc1] = "--26--- "; // 'u
        SC[28+sc1] = "--27--- "; // '
        SC[29+sc1] = "--28--- "; // '
        SC[30+sc1] = "--29--- "; // '
        // 781 Chordon Shortcuts in total !!!
} // end of function

//-------------------- END OF CHARACTER TABLES -------------------


